unit demo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


//********* Permet de pivoter une image *********//
procedure pivote_image(var limage:timage;sens:integer);
var    i,j:integer;
       elbitmap:tbitmap;
begin
     elbitmap:=tbitmap.Create;
     case sens of
        90,-270: begin { pivote vers la droite }
                       elbitmap.Width:=limage.Picture.Bitmap.Height;
                       elbitmap.Height:=limage.Picture.Bitmap.Width;
                        for i:=0 to elbitmap.Width -1  do
                            for j := 0 to elbitmap.Height -1  do
                                elbitmap.Canvas.Pixels[i,j] := limage.picture.bitmap.Canvas.Pixels[j,(elbitmap.Width -i -1)];
                  end;
       -90,270 : begin { pivote vers la gauche }
                       elbitmap.Width:=limage.Picture.Bitmap.Height;
                       elbitmap.Height:=limage.Picture.Bitmap.Width;
                        for i:=0 to elbitmap.width -1  do
                            for j := 0 to elbitmap.Height   -1  do
                                elbitmap.Canvas.Pixels[i,j] := limage.picture.bitmap.Canvas.Pixels[(elBitmap.height -j -1),i];
                  end ;
       180,-180: begin { pivote deux fois succesives ~ retourne  }
                      elbitmap.Width:=limage.Picture.Bitmap.width;
                      elbitmap.Height:=limage.Picture.Bitmap.height;
                      for i:=0 to elbitmap.Width do
                          for j:=0 to elbitmap.height do
                              elbitmap.Canvas.Pixels[i,j]:=limage.picture.bitmap.Canvas.Pixels[elbitmap.Width -i , elbitmap.Height -j ]
                 end;
        else begin
                  elbitmap:=limage.Picture.Bitmap;
                  exit;
             end;
     end;
     limage.picture.Bitmap:=elbitmap;
end; { pivote_image }



procedure TForm1.Button1Click(Sender: TObject);
begin
           pivote_image(image1,-90);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
           pivote_image(image1,90);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
           pivote_image(image1,180);
end;

end.
